"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const joi_1 = __importDefault(require("@hapi/joi"));
const constants_1 = require("../../../constants");
const types_1 = require("../../../types");
const baseJob_1 = require("../baseJob");
const GenericAndroidJobSchema = baseJob_1.BaseAndroidJobSchema.concat(joi_1.default.object({
    type: joi_1.default.string().valid(constants_1.BuildType.Generic),
    nativeProjectDirectory: joi_1.default.string().default('android'),
    gradleCommand: joi_1.default.string().default(':app:assembleRelease'),
    artifactPath: joi_1.default.string().default('android/app/build/outputs/apk/release/app-release.apk'),
    secrets: joi_1.default.object({ files: types_1.FileListSchema.required() }).required(),
}));
exports.GenericAndroidJobSchema = GenericAndroidJobSchema;
//# sourceMappingURL=job.js.map