"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../../../constants");
const file_1 = require("../../../utils/file");
async function prepareJob(config, projectUrl, projectDir) {
    return {
        platform: constants_1.Platform.Android,
        projectUrl,
        type: constants_1.BuildType.Generic,
        secrets: {
            files: config.secretFiles ? await file_1.readFileList(config.secretFiles, projectDir) : [],
        },
        nativeProjectDirectory: 'android',
        gradleCommand: ':app:assembleRelease',
        artifactPath: 'android/app/build/outputs/apk/release/app-release.apk',
    };
}
exports.default = prepareJob;
//# sourceMappingURL=prepare.js.map