"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const joi_1 = __importDefault(require("@hapi/joi"));
const constants_1 = require("../../constants");
const job_1 = require("./generic/job");
const job_2 = require("./managed/job");
const AndroidJobSchema = joi_1.default.object({
    type: joi_1.default.string().valid(...Object.values(constants_1.BuildType)).required(),
})
    .when(joi_1.default.object({ type: constants_1.BuildType.Generic }).unknown(), { then: job_1.GenericAndroidJobSchema })
    .when(joi_1.default.object({ type: constants_1.BuildType.Managed }).unknown(), { then: job_2.ManagedAndroidJobSchema });
exports.AndroidJobSchema = AndroidJobSchema;
//# sourceMappingURL=job.js.map