"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const constants_1 = require("../../../constants");
async function prepareJob(config, projectUrl, projectDir) {
    const keystoreLocalPath = path_1.default.join(projectDir, config.keystore.keystorePath);
    const keystoreDataBase64 = await fs_extra_1.default.readFile(keystoreLocalPath, 'base64');
    const keystore = {
        ...config.keystore,
        keystoreDataBase64,
    };
    const packageJson = await fs_extra_1.default.readFile(path_1.default.join(projectDir, 'package.json'), 'utf8');
    return {
        platform: constants_1.Platform.Android,
        projectUrl,
        type: constants_1.BuildType.Managed,
        secrets: { keystore },
        packageJson,
        manifest: 'TODO',
    };
}
exports.default = prepareJob;
//# sourceMappingURL=prepare.js.map