import { bunyan } from '@expo/logger';
import { iOSJob } from './job';
interface Credentials {
    bundleIdentifier: string;
    keychainPath: string;
    provisioningProfileUUID: string;
    teamId: string;
}
declare class iOSCredentialsManager {
    private job;
    private logger;
    private distributionCertificatePath;
    private provisioningProfile?;
    private keychain?;
    private cleanedUp;
    constructor(logger: bunyan, job: iOSJob);
    prepare(): Promise<{
        bundleIdentifier: string;
        keychainPath: string;
        provisioningProfileUUID: string;
        teamId: string;
    }>;
    cleanUp(): Promise<void>;
}
export { Credentials, iOSCredentialsManager };
