/// <reference types="node" />
import { bunyan } from '@expo/logger';
interface ProvisioningProfileData {
    bundleIdentifier: string;
    teamId: string;
    uuid: string;
    developerCertificate: Buffer;
}
declare class ProvisioningProfile {
    get data(): ProvisioningProfileData;
    private logger;
    private profile;
    private profilePath;
    private profileData?;
    constructor(logger: bunyan, profile: Buffer);
    init(): Promise<void>;
    destroy(): Promise<void>;
    verifyCertificate(fingerprint: string): void;
    private load;
    private genDerCertFingerprint;
}
export default ProvisioningProfile;
