"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SCREEN_ORIENTATION_ATTRIBUTE = 'android:screenOrientation';
function getOrientation(config) {
    return typeof config.orientation === 'string' ? config.orientation : null;
}
exports.getOrientation = getOrientation;
async function setAndroidOrientation(config, manifestDocument) {
    const orientation = getOrientation(config);
    if (!orientation) {
        return manifestDocument;
    }
    let mainActivity = manifestDocument.manifest.application[0].activity.filter((e) => e['$']['android:name'] === '.MainActivity');
    mainActivity[0]['$'][exports.SCREEN_ORIENTATION_ATTRIBUTE] = orientation;
    return manifestDocument;
}
exports.setAndroidOrientation = setAndroidOrientation;
//# sourceMappingURL=Orientation.js.map