"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DEFAULT_VERSION_NAME = '1.0';
const DEFAULT_VERSION_CODE = '1';
function getVersionName(config) {
    return config.version ? config.version : null;
}
exports.getVersionName = getVersionName;
function setVersionName(config, buildGradle, versionToReplace = DEFAULT_VERSION_NAME) {
    let versionName = getVersionName(config);
    if (versionName === null) {
        return buildGradle;
    }
    let pattern = new RegExp(`versionName "${versionToReplace}"`);
    return buildGradle.replace(pattern, `versionName "${versionName}"`);
}
exports.setVersionName = setVersionName;
function getVersionCode(config) {
    return config.android && config.android.versionCode ? config.android.versionCode : null;
}
exports.getVersionCode = getVersionCode;
function setVersionCode(config, buildGradle, versionCodeToReplace = DEFAULT_VERSION_CODE) {
    let versionCode = getVersionCode(config);
    if (versionCode === null) {
        return buildGradle;
    }
    let pattern = new RegExp(`versionCode ${versionCodeToReplace}`);
    return buildGradle.replace(pattern, `versionCode ${versionCode}`);
}
exports.setVersionCode = setVersionCode;
//# sourceMappingURL=Version.js.map