"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getName(config) {
    return typeof config.name === 'string' ? config.name : null;
}
exports.getName = getName;
/**
 * CFBundleDisplayName is used for most things: the name on the home screen, in
 * notifications, and others.
 */
function setDisplayName(configOrName, infoPlist) {
    let name = null;
    if (typeof configOrName === 'string') {
        name = configOrName;
    }
    else {
        name = getName(configOrName);
    }
    if (!name) {
        return infoPlist;
    }
    return Object.assign(Object.assign({}, infoPlist), { CFBundleDisplayName: name });
}
exports.setDisplayName = setDisplayName;
/**
 * CFBundleName is recommended to be 16 chars or less and is used in lists, eg:
 * sometimes on the App Store
 */
function setName(config, infoPlist) {
    let name = getName(config);
    if (!name) {
        return infoPlist;
    }
    return Object.assign(Object.assign({}, infoPlist), { CFBundleName: name });
}
exports.setName = setName;
//# sourceMappingURL=Name.js.map