"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const stream_1 = __importDefault(require("stream"));
const util_1 = require("util");
const node_fetch_1 = __importDefault(require("node-fetch"));
const pipeline = util_1.promisify(stream_1.default.pipeline);
async function downloadFile(srcUrl, outputPath, timeout) {
    const res = await node_fetch_1.default(srcUrl, { timeout });
    if (res.status !== 200) {
        throw new Error(`Failed to download the file, status code: ${res.status}`);
    }
    await pipeline(res.body, fs_1.default.createWriteStream(outputPath));
}
exports.default = downloadFile;
//# sourceMappingURL=index.js.map