/// <reference types="node" />
import { Readable } from 'stream';
import bunyan from '@expo/bunyan';
declare type LineLogger = (line: string) => void;
declare type LineTransformer = (line: string) => string | null;
interface SpawnOutput {
    stdout?: Readable | null;
    stderr?: Readable | null;
}
declare function pipe(stream: Readable, loggerFn: LineLogger, transformer?: LineTransformer): void;
declare function pipeSpawnOutput(logger: bunyan, { stdout, stderr }?: SpawnOutput, { printAsStdoutOnly }?: {
    printAsStdoutOnly?: boolean | undefined;
}): void;
export { pipe, pipeSpawnOutput };
