"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fill_1 = __importDefault(require("lodash/fill"));
const flatten_1 = __importDefault(require("lodash/flatten"));
const get_1 = __importDefault(require("lodash/get"));
const zip_1 = __importDefault(require("lodash/zip"));
exports.fieldPathToSchemaPath = (fieldPath) => {
    let newPath = zip_1.default(fill_1.default(fieldPath.split('.'), 'properties'), fieldPath.split('.'));
    return flatten_1.default(newPath).join('.');
};
// Assumption: used only for jsonPointer returned from traverse
exports.schemaPointerToFieldPath = (jsonPointer) => {
    return jsonPointer
        .split('/')
        .slice(2)
        .filter(e => e !== 'properties')
        .join('.');
};
exports.fieldPathToSchema = (schema, fieldPath) => {
    return get_1.default(schema, exports.fieldPathToSchemaPath(fieldPath));
};
//# sourceMappingURL=Util.js.map