"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const template_1 = __importDefault(require("lodash/template"));
const fs_extra_1 = __importDefault(require("fs-extra"));
async function templateFile(templateFilePath, envs, outputFilePath) {
    const templateString = await fs_extra_1.default.readFile(templateFilePath, 'utf8');
    const compiledTemplate = template_1.default(templateString, {
        // mustache
        interpolate: /{{([\s\S]+?)}}/g,
    });
    const outputFileContents = compiledTemplate(envs);
    if (outputFilePath) {
        await fs_extra_1.default.writeFile(outputFilePath, outputFileContents);
    }
    else {
        return outputFileContents;
    }
}
exports.default = templateFile;
//# sourceMappingURL=templateFile.js.map