"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = require("@expo/logger");
const spawn_async_1 = __importDefault(require("@expo/spawn-async"));
async function spawn(command, args, _options = {
    stdio: 'inherit',
    cwd: process.cwd(),
}) {
    const options = { ..._options };
    const { logger } = options;
    if (logger) {
        options.stdio = 'pipe';
    }
    const promise = spawn_async_1.default(command, args, options);
    if (logger && promise.child) {
        logger_1.pipeSpawnOutput(logger, promise.child, options);
    }
    return promise;
}
exports.default = spawn;
//# sourceMappingURL=index.js.map