"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Inject the required aliases for using React Native web and the extended Expo web ecosystem. Optionally can also safely append aliases to a Webpack config.
 *
 * @param webpackConfig Existing Webpack config to modify.
 * @param alias Extra aliases to inject
 * @category addons
 */
function withAlias(webpackConfig, alias = {}) {
    // Mix in aliases
    if (!webpackConfig.resolve)
        webpackConfig.resolve = {};
    webpackConfig.resolve.alias = Object.assign(Object.assign({}, (webpackConfig.resolve.alias || {})), alias);
    return webpackConfig;
}
exports.default = withAlias;
//# sourceMappingURL=withAlias.js.map