import { AnyConfiguration, InputEnvironment } from '../types';
/**
 * Enable or disable TypeScript in the Webpack config that's provided.
 * - Disabling will filter out any TypeScript extensions.
 * - Enabling will add fork TS checker to the plugins.
 *
 * @param webpackConfig input Webpack config to modify and return.
 * @param env Environment used to configure the input config.
 * @category addons
 */
export default function withTypeScriptAsync(webpackConfig: AnyConfiguration, env?: Pick<InputEnvironment, 'config' | 'locations' | 'projectRoot'>): Promise<AnyConfiguration>;
