import { GenerateSWOptions, InjectManifestOptions } from 'workbox-webpack-plugin';
import { AnyConfiguration } from '../types';
/**
 * @internal
 */
export declare type OfflineOptions = {
    projectRoot?: string;
    serviceWorkerPath?: string;
    autoRegister?: boolean;
    dev?: boolean;
    publicUrl?: string;
    scope?: string;
    useServiceWorker?: boolean;
    generateSWOptions?: GenerateSWOptions;
    injectManifestOptions?: InjectManifestOptions;
};
/**
 * Add offline support to the provided Webpack config.
 *
 * @param webpackConfig Existing Webpack config to modify.
 * @param options configure the service worker.
 * @category addons
 */
export default function withWorkbox(webpackConfig: AnyConfiguration, options?: OfflineOptions): AnyConfiguration;
