"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const paths_1 = require("@expo/config/paths");
/**
 * Get the platform specific platform extensions in the format that Webpack expects (with a dot prefix).
 *
 * @param platforms supported platforms in order of priority. ex: ios, android, web, native, electron, etc...
 * @category env
 */
function getModuleFileExtensions(...platforms) {
    // Webpack requires a `.` before each value
    return paths_1.getBareExtensions(platforms).map(value => `.${value}`);
}
exports.getModuleFileExtensions = getModuleFileExtensions;
//# sourceMappingURL=extensions.js.map