export declare function isPlatformSupported(): boolean;
export declare function getAdbOutputAsync(args: string[]): Promise<string>;
export declare function downloadApkAsync(url?: string, downloadProgressCallback?: (roundedProgress: number) => void): Promise<string>;
export declare function installExpoAsync(url?: string): Promise<string>;
export declare function uninstallExpoAsync(): Promise<string | undefined>;
export declare function upgradeExpoAsync(url?: string): Promise<boolean>;
export declare function assertDeviceReadyAsync(): Promise<void>;
export declare function openProjectAsync(projectRoot: string): Promise<{
    success: true;
    url: string;
} | {
    success: false;
    error: string;
}>;
export declare function openWebProjectAsync(projectRoot: string): Promise<{
    success: true;
    url: string;
} | {
    success: false;
    error: string;
}>;
export declare function startAdbReverseAsync(projectRoot: string): Promise<boolean>;
export declare function stopAdbReverseAsync(projectRoot: string): Promise<void>;
/**
 * Checks whether `resizeMode` is set to `native` and if `true` analyzes provided images for splashscreen
 * providing `Logger` feedback upon problems.
 * @param projectDir - directory of the expo project
 * @since SDK33
 */
export declare function checkSplashScreenImages(projectDir: string): Promise<void>;
export declare function maybeStopAdbDaemonAsync(): Promise<boolean>;
