import { ExpoConfig, PackageJSONConfig, ProjectTarget } from '@expo/config';
export declare type EmbeddedAssetsConfiguration = {
    projectRoot: string;
    pkg: PackageJSONConfig;
    exp: PublicConfig;
    releaseChannel?: string;
    iosManifestUrl: string;
    iosManifest: any;
    iosBundle: string;
    iosSourceMap: string | null;
    androidManifestUrl: string;
    androidManifest: any;
    androidBundle: string;
    androidSourceMap: string | null;
    target: ProjectTarget;
};
declare type PublicConfig = ExpoConfig & {
    sdkVersion: string;
};
export declare function configureAsync(config: EmbeddedAssetsConfiguration): Promise<void>;
export declare function getEmbeddedManifestPath(platform: 'ios' | 'android', projectRoot: string, exp: PublicConfig): string;
export declare function shouldEmbedAssetsForExpoUpdates(projectRoot: string, exp: PublicConfig, pkg: PackageJSONConfig, target: ProjectTarget): boolean;
export declare function getIOSPaths(projectRoot: string): {
    projectName: string;
    iosProjectDirectory: string;
    iosSupportingDirectory: string;
    iconPath: string;
};
export {};
