"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStandaloneBuilds = getStandaloneBuilds;

function _lodash() {
  const data = _interopRequireDefault(require("lodash"));

  _lodash = function () {
    return data;
  };

  return data;
}

function _ApiV() {
  const data = _interopRequireDefault(require("./ApiV2"));

  _ApiV = function () {
    return data;
  };

  return data;
}

function _User() {
  const data = _interopRequireDefault(require("./User"));

  _User = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function getStandaloneBuilds({
  id,
  platform,
  limit,
  slug,
  owner
}) {
  const user = await _User().default.ensureLoggedInAsync();

  const api = _ApiV().default.clientForUser(user);

  const params = {
    id,
    slug,
    platform,
    limit,
    status: 'finished',
    owner
  };
  const {
    builds
  } = await api.getAsync('standalone-build/get', params);
  return id || limit === 1 ? _lodash().default.first(builds) : builds;
}
//# sourceMappingURL=__sourcemaps__/StandaloneBuild.js.map
