import JsonFile from '@expo/json-file';
import { ConnectionType } from './User';
export declare type UserSettingsData = {
    accessToken?: string;
    auth?: UserData | null;
    ignoreBundledBinaries?: string[];
    openDevToolsAtStartup?: boolean;
    PATH?: string;
    sendTo?: string;
    uuid?: string;
};
export declare type UserData = {
    userId?: string;
    username?: string;
    currentConnection?: ConnectionType;
    sessionSecret?: string;
};
declare function userSettingsFile(): string;
declare function userSettingsJsonFile(): JsonFile<UserSettingsData>;
declare function recentExpsJsonFile(): any;
declare function dotExpoHomeDirectory(): string;
declare function anonymousIdentifier(): Promise<string>;
declare const UserSettings: JsonFile<UserSettingsData> & {
    dotExpoHomeDirectory: typeof dotExpoHomeDirectory;
    recentExpsJsonFile: typeof recentExpsJsonFile;
    userSettingsFile: typeof userSettingsFile;
    userSettingsJsonFile: typeof userSettingsJsonFile;
    anonymousIdentifier: typeof anonymousIdentifier;
    SETTINGS_FILE_NAME: string;
};
export default UserSettings;
