"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setWebhookAsync = setWebhookAsync;
exports.getWebhooksAsync = getWebhooksAsync;
exports.deleteWebhooksAsync = deleteWebhooksAsync;

function _ApiV() {
  const data = _interopRequireDefault(require("./ApiV2"));

  _ApiV = function () {
    return data;
  };

  return data;
}

function _User() {
  const data = _interopRequireDefault(require("./User"));

  _User = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function setWebhookAsync(experienceName, {
  url,
  secret,
  event
}) {
  const user = await _User().default.getCurrentUserAsync();

  const api = _ApiV().default.clientForUser(user);

  return await api.postAsync('webhook/set', {
    experienceName,
    url,
    secret,
    event
  });
}

async function getWebhooksAsync(experienceName) {
  const user = await _User().default.getCurrentUserAsync();

  const api = _ApiV().default.clientForUser(user);

  return await api.postAsync('webhook/get', {
    experienceName
  });
}

async function deleteWebhooksAsync(experienceName, event) {
  const user = await _User().default.getCurrentUserAsync();

  const api = _ApiV().default.clientForUser(user);

  return await api.postAsync('webhook/delete', {
    experienceName,
    event
  });
}
//# sourceMappingURL=__sourcemaps__/Webhooks.js.map
