import { ModuleConfig, NativeConfig } from './config';
declare type PlatformSpecificModuleConfig = ModuleConfig & NativeConfig;
declare type Platform = 'ios' | 'android';
export declare function getAllNativeModules(): {
    libName: string;
    sdkVersions: string;
    isNativeModule: boolean;
}[];
export declare function getAllForPlatform(platform: Platform, sdkVersion: string): PlatformSpecificModuleConfig[];
export declare function getAllNativeForExpoClientOnPlatform(platform: Platform, sdkVersion: string): PlatformSpecificModuleConfig[];
export declare function getVersionableModulesForPlatform(platform: Platform, sdkVersion: string): PlatformSpecificModuleConfig[];
export declare function getDetachableModules(platform: Platform, sdkVersion: string): PlatformSpecificModuleConfig[];
export declare function getPublishableModules(sdkVersion: string): ModuleConfig[];
export declare function doesVersionSatisfy(version: string, versionRequirement: string): boolean;
export {};
