"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeArtifactSafelyAsync = writeArtifactSafelyAsync;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _Logger() {
  const data = _interopRequireDefault(require("../Logger"));

  _Logger = function () {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function writeArtifactSafelyAsync(projectRoot, keyName, artifactPath, artifact) {
  const pathToWrite = _path().default.resolve(projectRoot, artifactPath);

  if (!_fsExtra().default.existsSync(_path().default.dirname(pathToWrite))) {
    const errorMsg = keyName ? `app.json specifies: ${pathToWrite}, but that directory does not exist.` : `app.json specifies ${keyName}: ${pathToWrite}, but that directory does not exist.`;

    _Logger().default.global.warn(errorMsg);
  } else {
    await _fsExtra().default.writeFile(pathToWrite, artifact);
  }
}
//# sourceMappingURL=../__sourcemaps__/tools/ArtifactUtils.js.map
